<template>
    <div class="modal">
        <div class="modal-mask"></div> 
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2 v-if="isEditMode">Edit <br>Quality rule</h2>
                    <h2 v-else>Create <br>New <br>Quality Rule</h2>
                    <div>
                        <nav>
                            <ul>
                                <li :class="{ 'active': currentStep === 1 }"><div><span>1</span>Rule Info</div></li>
                                <li :class="{ 'active': currentStep === 2 }"><div><span>2</span>Elements of rules</div></li>
                            </ul>
                        </nav>
                    </div>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Quality Rule Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="rule-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Quality Rule Info</h2>
                            <p>Establish a new quality assessment rule to ensure your datasets meet the required standards.<br>Provide a clear and detailed description to define the criteria and metrics for evaluation.</p>
                        </div>
                        <div class="big-title"><span class="bit-title-text">Forecast Previsions</span> <span class="type-artifact">Artifact</span></div>
                        <div class="step-border-rule">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Introduce a title</label>
                                <input type="text" name="title" required data-error-message="Fill in this field." />
                            </div>
                        </div>
                        <div class="step-border-rule">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>2.</span>Introduce a description</label>
                           
                                <div class="modal-input col-100">
                                    <label for="full-description">Full description</label>
                                    <input type="text" name="full-description" required data-error-message="Fill in this field." />
                                </div>
                            </div>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>3.</span>Select the Categories and Dimensions</label>
                            </div>
                            <div class="modal-box">
                                <div class="modal-box-search">
                                    <h3>Vocabularies/Terms</h3>
                                    <div class="search-wrapper">
                                        <input type="text" name="platform-search" class="input-search">
                                    </div>
                                </div>
                                <div class="modal-list">
                                    <div class="modal-list-item" @click="toggleClass(1)" :class="{ active: isActive(1) }">
                                        <div class="item-title">
                                            <label class="form-group-checkbox">
                                                <input type="checkbox" @click.stop>
                                                <div class="checkbox__checkmark"></div>
                                            </label>
                                            <h3>Mathematics <sup>11</sup></h3><i class="icon-arrow-down"></i>
                                        </div>
                                        <div class="list" @click.stop>
                                            <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                                <li>
                                                    <input type="checkbox" id="term1">
                                                    <label for="term1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term2">
                                                    <label for="term2">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term3">
                                                    <label for="term3">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term4">
                                                    <label for="term4">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term5">
                                                    <label for="term5">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term6">
                                                    <label for="term6">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term7">
                                                    <label for="term7">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term8">
                                                    <label for="term8">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <span class="see-more-terms">
                                                        <i class="icon-add add"></i>
                                                        100
                                                        <i class="icon-arrow-down arrow"></i>
                                                    </span>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="modal-list-item" @click="toggleClass(2)" :class="{ active: isActive(2) }">
                                        <div class="item-title">
                                            <label class="form-group-checkbox">
                                                <input type="checkbox" @click.stop>
                                                <div class="checkbox__checkmark"></div>
                                            </label>
                                            <h3>Computer Science / Finance <sup>29</sup></h3><i class="icon-arrow-down"></i>
                                        </div>
                                        <div class="list" @click.stop>
                                            <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                                <li>
                                                    <input type="checkbox" id="term1-1">
                                                    <label for="term1-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term2-1">
                                                    <label for="term2-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term3-1">
                                                    <label for="term3-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term4-1">
                                                    <label for="term4-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term5-1">
                                                    <label for="term5-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term6-1">
                                                    <label for="term6-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term7-1">
                                                    <label for="term7-1">Blockchain Tecnhology</label>
                                                </li>
                                                <li>
                                                    <input type="checkbox" id="term8-1">
                                                    <label for="term8-1">Blockchain Tecnhology</label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="modal-list-item" @click="toggleClass(3)" :class="{ active: isActive(3) }">
                                        <div class="item-title">
                                            <label class="form-group-checkbox">
                                                <input type="checkbox" @click.stop>
                                                <div class="checkbox__checkmark"></div>
                                            </label>
                                            <h3>Medicine / Health Sciences</h3><i class="icon-arrow-down"></i>
                                        </div>
                                        <div class="list" @click.stop>
                                            <ul class="modal-box-checkbox-list modal-box-checkbox-list">
                                                <li>
                                                    <input type="checkbox" id="term1-3">
                                                    <label for="term1-3">Other</label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>  
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 2 - Confirmation === -->
                <div id="step-2" class="step" v-show="currentStep === 2">
                    <div class="title">
                        <span class="step-number">2</span>
                        <h2>Rule Elements</h2>
                        <p>Specify the elements that make up this quality assessment rule.<br>Clearly outline the criteria and metrics to ensure precise and effective evaluation of your datasets.</p>
                    </div>
                    <div class="confirmation-wrapper">
                        <div class="rule-item">
                            <div class="rule-profiling">
                                <div class="rule-profiling-text">Include rule as part of the profiling process.</div>
                                <div class="form-check form-switch">
                                    <input class="form-check-input" type="checkbox" id="include-in-profiling">
                                    <label class="form-check-label" for="include-in-profiling"></label>
                                </div>
                            </div>
                            <div class="rule-item-line">
                                <div class="row row-rule">
                                    <div class="first-col">
                                        <div class="rule-item-line__number">01</div>
                                    </div>
                                    <div class="operands-col">
                                        <Dropdown :menu="menu" @selection="handleSelection" initialLabel="Not defined" title="1st Operand" />
                                    </div>
                                    <div class="operant-col">
                                        <Dropdown :menu="menuOperator" :oneLevel="true" @selection="handleSelection" initialLabel="Not defined" title="Operator" />
                                    </div>
                                    <div class="operands-col">
                                        <Dropdown :menu="menu" @selection="handleSelection" initialLabel="Not defined" title="2nd Operand" />
                                    </div>
                                    <div class="delete-col">
                                        <a href="#" class="button button-icon rounded"><i class="icon-delete"></i></a>
                                    </div>
                                </div>
                            </div>
                            <div class="rule-operator-line">
                                <div class="row">
                                    <div :class="['first-col rule-operator-col', operator]">
                                        <div class="rule-operator"  @click="operatorClick">
                                            <div class="operator-text">{{ operator }}</div>
                                            <i class="icon-reload"></i>
                                        </div>
                                    </div>
                                </div>
                                
                            </div>
                            <QualityRulesLine v-for="(line, index) in lines" 
                                :key="index" 
                                :operator="operator"
                                :lineNumber="(index + 2).toString().padStart(2, '0')"
                                @addLine="addLine"
                                @deleteLine="removeLine(index)"  />
                        
                        </div>
                        <div class="rules-values-area">
                            <div class="rules-values-item">
                                <div class="rules-values-text">Lower threshold (Red to orange):</div>
                                <div class="rules-values-input">
                                    <input type="text" name="lower-threshold" placeholder="Enter a value">
                                    <Tooltip tooltipText="A value between 0-100. This value will be used to determine the lower limit for red color." />
                                </div>
                            </div>
                            <div class="rules-values-item">
                                <div class="rules-values-text">Upper threshold (Red to orange):</div>
                                <div class="rules-values-input">
                                    <input type="text" name="lower-threshold" placeholder="Enter a value">
                                    <Tooltip tooltipText="A value between 0-100. This value will be used to determine the lower limit for orange color." />
                                </div>
                            </div>
                        </div>
                        
                    </div>
                </div>

            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step"
                    @click="previousStep">Back</button>
                <button class="button-secondary orange" id="next-step" @click="handleNextClick"
                    v-if="currentStep !== 2">Next</button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import Tooltip from '../tooltips/Tooltip.vue';

const props = defineProps({
    row: { 
        type: undefined as any, 
        required: false 
    },
    isEditMode: {
        type: Boolean,
        required: false
    }
});

const operator = ref('or');
const lines = ref([0]);

const emit = defineEmits(['toggle']);

const closeModal = () => {
    emit('toggle');
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

const operatorClick = () =>{
    if(operator.value === 'or'){
        operator.value = 'and';
    } else {
        operator.value = 'or';
    }
}

const addLine = () => {
    lines.value.push(lines.value.length);
}

const removeLine = (index: number) => {
    if(index >= 1){
        lines.value.splice(index, 1);
    }
};

const currentStep = ref<number>(1);
const menu = ref([
    {
        id: 1,
        label: "Select Column",
        submenu: [
            { id: 11, label: "Data column name 1" },
            { id: 12, label: "Data column name 2" },
            { id: 13, label: "Data column name 3" },
            { id: 14, label: "Data column name 4" },
        ],
    },
    {
    id: 2,
        label: "Select KPI",
        submenu: [
            { id: 21, label: "KPI name 1" },
            { id: 22, label: "KPI name 2" },
            { id: 22, label: "KPI name 3" },
            { id: 22, label: "KPI name 4" },
        ],
    },
]);

const menuOperator = ref([
    {
        id: 1,
        label: "Greater than",
        symbol: ">"
    },
    {
        id: 2,
        label: "Less than",
        symbol: "<"
    },
    {
        id: 3,
        label: "Equal to",
        symbol: "="
    },
    {
        id: 4,
        label: "Greater than or equal to",
        symbol: ">="
    },
    {
        id: 5,
        label: "Less than or equal to",
        symbol: "<="
    },
    {
        id: 6,
        label: "In",
        symbol: ""
    },
    {
        id: 7,
        label: "Regex.Match",
        symbol: ""
    }
]);

const handleSubmit = () => {
    
}

const handleNextClick = () => {
    nextStep();
}

const nextStep = () => {
    if (currentStep.value < 2) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}

const activeRule = ref(new Set<number>());

const toggleClass = (id: number) => {
    if (activeRule.value.has(id)) {
        activeRule.value.delete(id);
    } else {
        activeRule.value.add(id);
    }
};

const isActive = (id: number) => {
    return activeRule.value.has(id);
};

const handleSelection = (item: any) => {
      console.log("Selected item:", item);
}

</script>